#
# Table definitions for the R-GMA registry
#

CREATE TABLE producers(
        URL VARCHAR(100) NOT NULL,
        resourceId INT NOT NULL,
        tableName VARCHAR(200) NOT NULL,
        tableVersion INT NOT NULL,
        supportsStatic VARCHAR(200),
        supportsContinuous VARCHAR(5),
        supportsLatest VARCHAR(5),
        supportsHistory VARCHAR(5),
        isRepublisher VARCHAR(5),
        hasPredicate VARCHAR(5),
        retentionPeriod BIGINT,
        qosAttrib VARCHAR(255),
        terminationInterval BIGINT,
        lastContactTime BIGINT,
        replicaOrigin VARCHAR(130) NOT NULL,
        replicaStatus SMALLINT NOT NULL,
        PRIMARY KEY (URL, resourceId, tableName, 
            tableVersion, replicaOrigin));

CREATE TABLE consumers(
        URL VARCHAR(100) NOT NULL,
        resourceId INT NOT NULL,
        tableName VARCHAR(200) NOT NULL,
        tableVersion INT NOT NULL,
        predicate VARCHAR(255),
        queryType ENUM('Latest','History','Continuous','Static'),
        queryPeriod BIGINT,
        isRepublisher VARCHAR(5),
        qosAttrib VARCHAR(255),
        terminationInterval BIGINT,
        lastContactTime BIGINT,
        replicaOrigin VARCHAR(130) NOT NULL,
        replicaStatus SMALLINT NOT NULL,
        PRIMARY KEY (URL, resourceId, replicaOrigin));

CREATE TABLE fixedVarcharColumns(
        tableName VARCHAR(200) NOT NULL,
        URL VARCHAR(100) NOT NULL,
        resourceId INT NOT NULL,
        columnName VARCHAR(50) NOT NULL,
        columnValue TEXT NOT NULL,
        replicaOrigin VARCHAR(130) NOT NULL,
        replicaStatus SMALLINT NOT NULL,
        PRIMARY KEY (tableName, URL, resourceId, 
            columnName, replicaOrigin));

CREATE TABLE fixedIntegerColumns(
        tableName VARCHAR(200) NOT NULL,
        URL VARCHAR(100) NOT NULL,
        resourceId INT NOT NULL,
        columnName VARCHAR(50) NOT NULL,
        columnValue INT NOT NULL,
        replicaOrigin VARCHAR(130) NOT NULL,
        replicaStatus SMALLINT NOT NULL,
        PRIMARY KEY (tableName, URL, resourceId, 
            columnName, replicaOrigin));

CREATE TABLE fixedDoubleColumns(
        tableName VARCHAR(200) NOT NULL,
        URL VARCHAR(100) NOT NULL,
        resourceId INT NOT NULL,
        columnName VARCHAR(50) NOT NULL,
        columnValue DOUBLE NOT NULL,
        replicaOrigin VARCHAR(130) NOT NULL,
        replicaStatus SMALLINT NOT NULL,
        PRIMARY KEY (tableName, URL, resourceId, 
            columnName, replicaOrigin));

CREATE TABLE fixedTimeStampColumns(
        tableName VARCHAR(200) NOT NULL,
        URL VARCHAR(100) NOT NULL,
        resourceId INT NOT NULL,
        columnName VARCHAR(50) NOT NULL,
        columnValue DATETIME NOT NULL,
        replicaOrigin VARCHAR(130) NOT NULL,
        replicaStatus SMALLINT NOT NULL,
        PRIMARY KEY (tableName, URL, resourceId, 
            columnName, replicaOrigin));