#
# Table definitions for the R-GMA registry
#

CREATE TABLE info(registryVersion VARCHAR(20) NOT NULL,
		   infoVersion VARCHAR(20),
 		   producersVersion VARCHAR(20),
           fixedColumnsVersion VARCHAR(20),
           replicaOrigin VARCHAR(130) NOT NULL,
           replicaStatus SMALLINT NOT NULL,
           PRIMARY KEY (registryVersion, replicaOrigin));

INSERT INTO info VALUES('0.4','0.4','0.4','0.3',
    'http://localhost.localdomain:8080/R-GMA/RegistryServlet',0);

CREATE TABLE producers(tableName VARCHAR(200) NOT NULL,
			flags TINYINT(5),
			URL VARCHAR(100) NOT NULL,
            connectionId INT UNSIGNED NOT NULL,
            clientTimeStamp BIGINT,
            terminationTime BIGINT,
            replicaOrigin VARCHAR(130) NOT NULL,
            replicaStatus SMALLINT NOT NULL,
            PRIMARY KEY (tableName, URL, connectionId, replicaOrigin));

CREATE TABLE consumers(URL VARCHAR(100) NOT NULL, 
            connectionId INT UNSIGNED NOT NULL, 
            tableName VARCHAR(200) NOT NULL, 
            predicate VARCHAR(255), 
            flags TINYINT(5),
            clientTimeStamp BIGINT,
            terminationTime BIGINT,
            replicaOrigin VARCHAR(130) NOT NULL,
            replicaStatus SMALLINT NOT NULL,
            PRIMARY KEY (tableName, URL, connectionId, replicaOrigin));

CREATE TABLE fixedStringColumns(tableName VARCHAR(200) NOT NULL,
			URL VARCHAR(100) NOT NULL,
            connectionId INT UNSIGNED NOT NULL,
            columnName VARCHAR(50) NOT NULL, 
            value VARCHAR(255) NOT NULL,
            replicaOrigin VARCHAR(130) NOT NULL,
            replicaStatus SMALLINT NOT NULL,
            PRIMARY KEY (tableName, URL, connectionId, 
            columnName, replicaOrigin));

CREATE TABLE fixedIntColumns(tableName VARCHAR(200) NOT NULL,
			URL VARCHAR(100) NOT NULL,
            connectionId INT UNSIGNED NOT NULL,
            columnName VARCHAR(50) NOT NULL, 
            value INT NOT NULL,
            replicaOrigin VARCHAR(130) NOT NULL,
            replicaStatus SMALLINT NOT NULL,
            PRIMARY KEY (tableName, URL, connectionId, columnName, 
            replicaOrigin));

CREATE TABLE fixedRealColumns(tableName VARCHAR(200) NOT NULL,
			URL VARCHAR(100) NOT NULL,
            connectionId INT UNSIGNED NOT NULL,
            columnName VARCHAR(50) NOT NULL, 
            value REAL NOT NULL,
            replicaOrigin VARCHAR(130) NOT NULL,
            replicaStatus SMALLINT NOT NULL,
            PRIMARY KEY (tableName, URL, connectionId, columnName, 
            replicaOrigin));

