######################################################################
# CONTENT ORIGINAL ORIGIN: gma/webapps/SchemaServlet/etc/SchemaSetup #
######################################################################

# Create the tables that make up the Schema
# =========================================
CREATE TABLE info( schemaVersion varchar(20),
                   infoVersion varchar(20),
                   producerTablesVersion varchar(20),
                   tableColumnsVersion varchar(20),
		   origin varchar(130) NOT NULL,
                   replicateStatus smallint(8) NOT NULL);

INSERT INTO info VALUES('0.3','0.2','0.3','0.2','http://localhost.localdomain:8080/R-GMA/SchemaServlet',0);

CREATE TABLE producerTables( tableId int(8) NOT NULL AUTO_INCREMENT,
		     	     name varchar(255) UNIQUE,
		     	     attributes varchar(100),	
		     	     description varchar(200),	
		     	     keyword1 varchar(25),
		     	     keyword2 varchar(25),
		   	     keyword3 varchar(25),
		             origin varchar(130) NOT NULL,
                             replicateStatus smallint(8) NOT NULL,
		    	     PRIMARY KEY (tableId,origin),
                     	     UNIQUE id (tableId,origin));
ALTER TABLE producerTables AUTO_INCREMENT = 0;

CREATE TABLE tableColumns( columnId int(8) NOT NULL AUTO_INCREMENT,
		    	   tableId int(8) REFERENCES producerTables(tableId),  
                     	   name varchar(50),
		     	   type varchar(50),
                           isPrimaryKey bit(1),
			   attributes varchar(50),
		 	   description varchar(100),
		           origin varchar(130) NOT NULL,
                           replicateStatus smallint(8) NOT NULL,
		    	   PRIMARY KEY (columnId,origin),
                      	   UNIQUE id (columnId,origin));
ALTER TABLE tableColumns AUTO_INCREMENT = 0;
